(***Cette partie permet de modifier la popularit des messages et le cot sans avoir  tout rinitialiser***)

#open "Variables";;
#open "Algorithmes";;

(*Pour remettre les variables  jour en cas de changement de nb_messages ou nb_canaux*)  
let reload T=
  init_popularite(); (*les popularits suivent la loi de Zipf*)
  init_couts(); (*les cots sont nuls*)
  init_Tau(); (*issu du minorant*)
  init_proba(); (*pour l'algo random*)
  init_ordonancement T; (*pour l'algo du nombre d'or*)
  init_arbre() (*pour l'algo se servant des arbres*);
  print_string "Variables initialises avec succs!";;

(*Pour pouvoir tester les algos sur d'autres distributions que Zipf*)
(*Pour pouvoir tudier les algos dynamiques*)
let change_popu l=
  nb_messages:=vect_length l;
  popularite:=normalise l;
  popu_cum:=cumul !popularite;
  (*Rinitialisation des algos qui dpendent videmment tous de la popularit!*)
  init_couts(); (*on rinitialise les cots  0 parceque le nombre des messages peut avoir changer*)
  init_Tau();
  init_proba();
  init_ordonancement (!T_nbor);
  init_arbre();
  !popularite;;
  
let change_couts c =
  if vect_length c <> !nb_messages then failwith "Erreur : il faut entrer un nombre de cots gal au nombre de messages!";
  couts:=c;
  init_Tau();
  init_proba();
  init_ordonancement (float_of_int(vect_length !ordonancement));
  init_arbre();
  couts;;   