(*************Permet de charger les modules et d'initialiser les constantes********************)

directory "C:\Documents and Settings\Dams\Mes documents\Tipe\Dissmination de Donnes";;
#open "Variables";;
#open "Algorithmes";;
#open "ChangeDyna";;
#open "Simulation";;

random__init (int_of_float (sys__time()));;
let io s=print_string s;print_newline();
         int_of_string(read_line());;
let io_float s=print_string s;print_newline();
               float_of_string(read_line());; 
  
(*Pour initialiser les variables*)
let launch()=
  nb_canaux:=io "Entrez le nombre de canaux: ";
  nb_messages:=io "Entrez le nombre de messages: ";
  T_nbor:=io_float "Priode de l'ordonancement? ";
  reload !T_nbor;
  print_string "\nPour dmarrer la simulation: simul_all longueur nb_de_clients";
  print_string "\nRemarque: Pour avoir des rsultats fiables, il est recommand que";
  print_string "\nlongueur=10*nb_messages voire 100*nb_messages";
  print_string "\nLe minorant est asymptotique est n'est valabe que pour les algorithmes de dissmination de donnes";
  print_string "\nDes algorithmes peuvent donc avoir un temps de service infrieur au minorant!";;
     

(* Comme launch sauf qu'on entre directement la valeur des variables en argument *)
let result nbcanaux nbmessages Tnbor algo longsimu freqsimu=
  nb_canaux:=nbcanaux;
  nb_messages:=nbmessages;
  reload Tnbor;
  simul algo longsimu freqsimu;;



(**Utilis pour faire des courbes  partir des donnes de la simulation**)
let enregistre debut fin step=
  let sortie1=open_out "C:\Temp\Simul2\Nombre de clients1.txt" in
  let sortie2=open_out "C:\Temp\Simul2\Glouton1.txt" in
  let pos_GLOBAL=ref debut in
  while !pos_GLOBAL<fin do
    output_string sortie1 (string_of_int !pos_GLOBAL);output_string sortie1 "\n";
    let r=result 1 100 (float_of_int(!pos_GLOBAL*10)) GLOUTON 10000 !pos_GLOBAL in
    output_string sortie2 (string_of_float (arrondir r));output_string sortie2 "\n";
    pos_GLOBAL:=!pos_GLOBAL+step;
  done; 
close_out sortie1;
close_out sortie2;;

print_string "\nPour lancer: launch()\n";;